Index: /branches/spaceshipcontrol/src/lib/graphics/importer/tc.cc
===================================================================
--- /branches/spaceshipcontrol/src/lib/graphics/importer/tc.cc	(revision 6484)
+++ /branches/spaceshipcontrol/src/lib/graphics/importer/tc.cc	(revision 6485)
@@ -47,5 +47,5 @@
 typedef struct TableIterator {
     int i1, i2, i3;
-    uint i;
+    unsigned int i;
     TableLevel3 *CurLevel3;
     int CheckLevel1, CheckLevel2;
@@ -70,5 +70,5 @@
 }
 
-int tableRetrieve(uint a, TableRoot *table, void **ref)
+int tableRetrieve(unsigned int a, TableRoot *table, void **ref)
 {
     int i1 = a / (LEVEL2COUNT * LEVEL3COUNT);
@@ -87,5 +87,5 @@
 }
 
-int tableInsert(uint a, TableRoot *table, void *ref)
+int tableInsert(unsigned int a, TableRoot *table, void *ref)
 {
     int i1 = a / (LEVEL2COUNT * LEVEL3COUNT);
@@ -120,5 +120,5 @@
 }
 
-int tableRemove(uint a, TableRoot *table, void **wasref)
+int tableRemove(unsigned int a, TableRoot *table, void **wasref)
 {
     int i1 = a / (LEVEL2COUNT * LEVEL3COUNT);
@@ -161,5 +161,5 @@
 }
 
-int tableIterate(TableRoot *table, TableIterator *ti, uint *i, void **ref)
+int tableIterate(TableRoot *table, TableIterator *ti, unsigned int *i, void **ref)
 {
     int done;
@@ -287,5 +287,5 @@
 
 typedef struct ACTCVertex {
-    uint V;
+    unsigned int V;
     int Count;
     struct ACTCVertex **PointsToMe;
@@ -315,5 +315,5 @@
     ACTCVertex *StaticVerts;
     int UsingStaticVerts;
-    uint VertRange;
+    unsigned int VertRange;
 
     /* During consolidation */
@@ -330,6 +330,6 @@
 
     /* actcParam-settable parameters */
-    uint MinInputVert;
-    uint MaxInputVert;
+    unsigned int MinInputVert;
+    unsigned int MaxInputVert;
     int MaxVertShare;
     int MaxEdgeShare;
@@ -464,5 +464,5 @@
 }
 
-static void *reallocAndAppend(void **ptr, uint *itemCount, size_t itemBytes,
+static void *reallocAndAppend(void **ptr, unsigned int *itemCount, size_t itemBytes,
     void *append)
 {
@@ -487,5 +487,5 @@
  * going to be less than the number of vertices.)
  */
-static int incVertexValence(ACTCData *tc, uint v, ACTCVertex **found)
+static int incVertexValence(ACTCData *tc, unsigned int v, ACTCVertex **found)
 {
     ACTCVertex *vertex;
@@ -959,5 +959,5 @@
 }
 
-int actcParamu(ACTCData *tc, int param, uint value)
+int actcParamu(ACTCData *tc, int param, unsigned int value)
 {
     /*
@@ -1016,5 +1016,5 @@
 }
 
-int actcGetParamu(ACTCData *tc, int param, uint *value)
+int actcGetParamu(ACTCData *tc, int param, unsigned int *value)
 {
     return actcGetParami(tc, param, (int *)value);
@@ -1028,5 +1028,5 @@
     tmp.FinalVert = v3;
     chartedSetLabel("triangle list");
-    r = reallocAndAppend((void **)&edge->Triangles, (uint*)&edge->TriangleCount,
+    r = reallocAndAppend((void **)&edge->Triangles, (unsigned int*)&edge->TriangleCount,
         sizeof(tmp), &tmp);
     if(r == NULL) {
@@ -1065,5 +1065,5 @@
 static int mapVertexEdge(ACTCData *tc, ACTCVertex *v1, ACTCVertex *v2, ACTCEdge **edge)
 {
-    uint i;
+    unsigned int i;
     ACTCEdge tmp;
     void *r;
@@ -1083,5 +1083,5 @@
 
 	chartedSetLabel("vert-to-edge mapping");
-        r = reallocAndAppend((void **)&v1->Edges, (uint*)&v1->EdgeCount,
+        r = reallocAndAppend((void **)&v1->Edges, (unsigned int*)&v1->EdgeCount,
 	    sizeof(tmp), &tmp);
 	if(r == NULL) {
@@ -1125,5 +1125,5 @@
 }
 
-int actcAddTriangle(ACTCData *tc, uint v1, uint v2, uint v3)
+int actcAddTriangle(ACTCData *tc, unsigned int v1, unsigned int v2, unsigned int v3)
 {
     ACTCVertex *vertexRec1;
@@ -1191,5 +1191,5 @@
 }
 
-int actcStartNextPrim(ACTCData *tc, uint *v1Return, uint *v2Return)
+int actcStartNextPrim(ACTCData *tc, unsigned int *v1Return, unsigned int *v2Return)
 {
     ACTCVertex *v1 = NULL;
@@ -1269,5 +1269,5 @@
 }
 
-int actcGetNextVert(ACTCData *tc, uint *vertReturn)
+int actcGetNextVert(ACTCData *tc, unsigned int *vertReturn)
 {
     ACTCEdge *edge;
@@ -1359,5 +1359,5 @@
 
 int actcTrianglesToPrimitives(ACTCData *tc, int triangleCount,
-    uint (*triangles)[3], int primTypes[], int primLengths[], uint vertices[],
+    unsigned int (*triangles)[3], int primTypes[], int primLengths[], unsigned int vertices[],
     int maxBatchSize)
 {
@@ -1365,7 +1365,7 @@
     int curTriangle;
     int curPrimitive;
-    uint curVertex;
+    unsigned int curVertex;
     int prim;
-    uint v1, v2, v3;
+    unsigned int v1, v2, v3;
     int lastPrim;
     int passesWithoutPrims;
Index: /branches/spaceshipcontrol/src/lib/graphics/text_engine/font.cc
===================================================================
--- /branches/spaceshipcontrol/src/lib/graphics/text_engine/font.cc	(revision 6484)
+++ /branches/spaceshipcontrol/src/lib/graphics/text_engine/font.cc	(revision 6485)
@@ -247,5 +247,5 @@
  * @param fileName the File to write the image into.
  */
-void Font::createAsciiImage(const char* fileName, uint size) const
+void Font::createAsciiImage(const char* fileName, unsigned int size) const
 {
   if (this->fontTTF == NULL)
Index: /branches/spaceshipcontrol/src/lib/graphics/text_engine/font.h
===================================================================
--- /branches/spaceshipcontrol/src/lib/graphics/text_engine/font.h	(revision 6484)
+++ /branches/spaceshipcontrol/src/lib/graphics/text_engine/font.h	(revision 6485)
@@ -78,5 +78,5 @@
     inline static Font* getDefaultFont() { if (Font::defaultFont == NULL) initDefaultFont(); return Font::defaultFont; };
 
-    void createAsciiImage(const char* fileName, uint size) const;
+    void createAsciiImage(const char* fileName, unsigned int size) const;
     static void initDefaultFont();
     static void removeDefaultFont();