Index: code/branches/pickup3/src/modules/pickup/DroppedPickup.h
===================================================================
--- code/branches/pickup3/src/modules/pickup/DroppedPickup.h	(revision 6492)
+++ code/branches/pickup3/src/modules/pickup/DroppedPickup.h	(revision 6496)
@@ -49,5 +49,5 @@
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport DroppedPickup : public PickupSpawner
+    class _PickupExport DroppedPickup : public PickupSpawner
     {
         public:
Index: code/branches/pickup3/src/modules/pickup/PickupPrereqs.h
===================================================================
--- code/branches/pickup3/src/modules/pickup/PickupPrereqs.h	(revision 6492)
+++ code/branches/pickup3/src/modules/pickup/PickupPrereqs.h	(revision 6496)
@@ -44,5 +44,5 @@
 
 #if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(ORXONOX_STATIC_BUILD)
-#  ifdef QUESTSYSTEM_SHARED_BUILD
+#  ifdef PICKUP_SHARED_BUILD
 #    define _PickupExport __declspec(dllexport)
 #  else
Index: code/branches/pickup3/src/modules/pickup/PickupSpawner.h
===================================================================
--- code/branches/pickup3/src/modules/pickup/PickupSpawner.h	(revision 6492)
+++ code/branches/pickup3/src/modules/pickup/PickupSpawner.h	(revision 6496)
@@ -54,5 +54,5 @@
             Damian 'Mozork' Frick
     */
-    class _OrxonoxExport PickupSpawner : public StaticEntity, public Tickable
+    class _PickupExport PickupSpawner : public StaticEntity, public Tickable
     {
         public:
Index: code/branches/pickup3/src/modules/pickup/items/HealthPickup.cc
===================================================================
--- code/branches/pickup3/src/modules/pickup/items/HealthPickup.cc	(revision 6492)
+++ code/branches/pickup3/src/modules/pickup/items/HealthPickup.cc	(revision 6496)
@@ -110,5 +110,5 @@
         Method for creating a HealthPickup object through XML.
     */
-    void HealthPickup::HealthPickup::XMLPort(Element& xmlelement, orxonox::XMLPort::Mode mode)
+    void HealthPickup::XMLPort(Element& xmlelement, orxonox::XMLPort::Mode mode)
     {
         SUPER(HealthPickup, XMLPort, xmlelement, mode);
Index: code/branches/pickup3/src/modules/pickup/items/HealthPickup.h
===================================================================
--- code/branches/pickup3/src/modules/pickup/items/HealthPickup.h	(revision 6492)
+++ code/branches/pickup3/src/modules/pickup/items/HealthPickup.h	(revision 6496)
@@ -55,9 +55,9 @@
     @brief
         A pickup that can do (dependent upon the parameters) lots of different things to the health of a Pawn.
-        There are 4 parameters that can be choosen:
+        There are 4 parameters that can be chosen:
         1) The health. The amount of health that (in a way dependent on the other parameters) is transfered to the Pawn.
         2) The activation type: It can be chosen to be either 'immediate' or 'onUse'. The activation type essentially (as indicated by the name) defines when the health is transfered, either immediately after being picked up or only after the player uses it.
         3) The duration type: It can be chosen to be either 'once' or 'continuous'. For 'once' the specified health is transfered once to the Pawn, for 'continuous' the set health is transfered over a span of time at a rate defined by the health rate parameter.
-        4) The health type: The health type can be choosen to be 'limited', 'temporary' or 'permanent'. 'limited' means that the health is increased only to the maximum health of the Pawn. 'temporary' means that the maximum health is temporarily elevated but will be set back as soon as the pickup is no longer in use. 'permanent' means that the maximum health of the Pawn is increased such that the health provided by the pickup will fit in and the maximum health stays that way.
+        4) The health type: The health type can be chosen to be 'limited', 'temporary' or 'permanent'. 'limited' means that the health is increased only to the maximum health of the Pawn. 'temporary' means that the maximum health is temporarily elevated but will be set back as soon as the pickup is no longer in use. 'permanent' means that the maximum health of the Pawn is increased such that the health provided by the pickup will fit in and the maximum health stays that way.
     @author
         Damian 'Mozork' Frick