Index: branches/network/src/util/hud.cc
===================================================================
--- trunk/src/util/hud.cc	(revision 6468)
+++ branches/network/src/util/hud.cc	(revision 6500)
@@ -143,6 +143,6 @@
 void Hud::updateResolution()
 {
-  this->resX = State::resX();
-  this->resY = State::resY();
+  this->resX = State::getResX();
+  this->resY = State::getResY();
   if (this->energyWidget != NULL)
   {
@@ -174,5 +174,5 @@
 void Hud::tick(float dt)
 {
-  if (this->resY != State::resY() || this->resX != State::resY())
+  if (this->resY != State::getResY() || this->resX != State::getResY())
     this->updateResolution();
 }
Index: branches/network/src/util/state.cc
===================================================================
--- trunk/src/util/state.cc	(revision 6468)
+++ branches/network/src/util/state.cc	(revision 6500)
@@ -29,11 +29,16 @@
 PNode* State::cameraTarget = NULL;
 
-Player* State::_localPlayer = NULL;
-SkyBox* State::_skyBox = NULL;
+SkyBox* State::skyBox = NULL;
 
 ObjectManager* State::objectManager = NULL;
 
-unsigned int State::_resX = 1;
-unsigned int State::_resY = 1;
+
+unsigned int State::resX = 1;
+unsigned int State::resY = 1;
+
+StoryEntity* State::storyEntity = NULL;
+
+Player* State::player = NULL;
+
 
 /**
Index: branches/network/src/util/state.h
===================================================================
--- trunk/src/util/state.h	(revision 6468)
+++ branches/network/src/util/state.h	(revision 6500)
@@ -7,10 +7,12 @@
 #define _STATE_H
 
+
 // FORWARD DECLARATION
 class PNode;
 class WorldEntity;
+class Player;
+class SkyBox;
+class StoryEntity;
 class ObjectManager;
-class SkyBox;
-class Player;
 
 
@@ -34,14 +36,11 @@
   static inline PNode* getCameraTarget() { return State::cameraTarget; };
 
-  /** @returns the Local Player */
-  static inline Player* localsPlayer() { return State::_localPlayer; };
-  /** @param localPlayer the local Player */
-  static inline void setLocalPlayer(Player* localPlayer) { State::_localPlayer = localPlayer; };
-
+  ////////////////
+  /// SKYBOX   ///
+  ////////////////
   /** @returns the current SkyBox */
-  static inline SkyBox* skyBox() { return State::_skyBox; };
+  static inline SkyBox* getSkyBox() { return State::skyBox; };
   /** @param skyBox the SkyBox */
-  static inline SkyBox* setSkyBox(SkyBox* skyBox) { State::_skyBox = skyBox; };
-
+  static inline SkyBox* setSkyBox(SkyBox* skyBox) { State::skyBox = skyBox; };
 
   //////////////////////
@@ -53,12 +52,25 @@
   static inline ObjectManager* getObjectManager() { return State::objectManager; };
 
+  static inline void setResolution(unsigned int resX, unsigned int resY) { State::resX = resX; State::resY = resY; };
+  static inline unsigned int getResX() { return State::resX; };
+  static inline unsigned int getResY() { return State::resY; };
 
-  static inline void setResolution(unsigned int resX, unsigned int resY) { State::_resX = resX; State::_resY = resY; };
-  static inline unsigned int resX() { return State::_resX; };
-  static inline unsigned int resY() { return State::_resY; };
+  //////////////////////
+  /// STORY-ENTITY   ///
+  //////////////////////
+  /** @param storyEntity sets the current StoryEntity that is been played */
+  static inline void setCurrentStoryEntity(StoryEntity* storyEntity) { State::storyEntity = storyEntity; };
+  /** @returns the current StoryEntity played */
+  static inline StoryEntity* getCurrentStoryEntity() { return State::storyEntity; };
 
-  /////////////////////////
-  /// WORLD_ENTITY_LIST ///
-  /////////////////////////
+  //////////////
+  /// PLAYER ///
+  //////////////
+  /** @param player sets the current local player */
+  static inline void setPlayer(Player* player) { State::player = player; };
+  /** @returns the local player*/
+  static inline Player* getPlayer() { return State::player; };
+
+
 
  private:
@@ -68,10 +80,11 @@
   static PNode*                 cameraTarget;       //!< A reference to the cameraTarget
   static PNode*                 nullParent;         //!< A reference to the Null-PNode.
-  static ObjectManager*         objectManager;      //!< A referenct to the current ObjectManager
+  static ObjectManager*         objectManager;      //!< A reference to the current ObjectManager
+  static StoryEntity*           storyEntity;        //!< A reference to the current StoryEntity played
+  static Player*                player;             //!< A reference to the Player
 
-  static Player*                _localPlayer;       //!< The Local Player.
-  static SkyBox*                _skyBox;            //!< The SkyBox used in the current world.
-  static unsigned int           _resX;              //!< The X Resolution of the screen.
-  static unsigned int           _resY;              //!< The Y Resolution of the screen.
+  static SkyBox*                skyBox;            //!< The SkyBox used in the current world.
+  static unsigned int           resX;              //!< The X Resolution of the screen.
+  static unsigned int           resY;              //!< The Y Resolution of the screen.
   };
 