Index: code/trunk/src/libraries/core/Resource.cc
===================================================================
--- code/trunk/src/libraries/core/Resource.cc	(revision 6443)
+++ code/trunk/src/libraries/core/Resource.cc	(revision 6501)
@@ -79,5 +79,5 @@
         }
         Ogre::FileInfoListPtr infos = Ogre::ResourceGroupManager::getSingleton().findResourceFileInfo(group, name);
-        for (std::vector<Ogre::FileInfo>::const_iterator it = infos->begin(); it != infos->end(); ++it)
+        for (Ogre::FileInfoList::const_iterator it = infos->begin(); it != infos->end(); ++it)
         {
             if (it->filename == name)
Index: code/trunk/src/modules/objects/Planet.cc
===================================================================
--- code/trunk/src/modules/objects/Planet.cc	(revision 6443)
+++ code/trunk/src/modules/objects/Planet.cc	(revision 6501)
@@ -91,14 +91,20 @@
         float scaleFactor = this->getScale();
 
-        this->distList.push_back(10.0f*scaleFactor);
-        this->distList.push_back(19.0f*scaleFactor);
-        this->distList.push_back(27.0f*scaleFactor);
-        this->distList.push_back(34.0f*scaleFactor);
-        this->distList.push_back(40.0f*scaleFactor);
-        this->distList.push_back(45.0f*scaleFactor);
-        this->distList.push_back(49.0f*scaleFactor);
-        this->distList.push_back(52.0f*scaleFactor);
-        this->distList.push_back(54.0f*scaleFactor);
-        this->distList.push_back(55.0f*scaleFactor);
+#if OGRE_VERSION >= 0x010700
+        Ogre::Mesh::LodValueList distList;
+#else
+        Ogre::Mesh::LodDistanceList distList;
+#endif
+
+        distList.push_back(10.0f*scaleFactor);
+        distList.push_back(19.0f*scaleFactor);
+        distList.push_back(27.0f*scaleFactor);
+        distList.push_back(34.0f*scaleFactor);
+        distList.push_back(40.0f*scaleFactor);
+        distList.push_back(45.0f*scaleFactor);
+        distList.push_back(49.0f*scaleFactor);
+        distList.push_back(52.0f*scaleFactor);
+        distList.push_back(54.0f*scaleFactor);
+        distList.push_back(55.0f*scaleFactor);
 
         float reductionValue = 0.2f;
Index: code/trunk/src/modules/objects/Planet.h
===================================================================
--- code/trunk/src/modules/objects/Planet.h	(revision 6443)
+++ code/trunk/src/modules/objects/Planet.h	(revision 6501)
@@ -106,5 +106,4 @@
             float atmosphereSize;
             float imageSize;
-            std::vector<float> distList;
             BillboardSet billboard_;
             bool bCastShadows_;
Index: code/trunk/src/orxonox/LevelManager.cc
===================================================================
--- code/trunk/src/orxonox/LevelManager.cc	(revision 6443)
+++ code/trunk/src/orxonox/LevelManager.cc	(revision 6501)
@@ -132,14 +132,14 @@
     void LevelManager::compileAvailableLevelList()
     {
-        availableLevels_ = *Resource::findResourceNames("*.oxw");
-        for (std::vector<std::string>::iterator it = availableLevels_.begin(); it != availableLevels_.end();)
-            if (it->find("old/") == 0)
-                it = availableLevels_.erase(it);
-            else
+        this->availableLevels_.clear();
+        Ogre::StringVectorPtr levels = Resource::findResourceNames("*.oxw");
+        for (Ogre::StringVector::const_iterator it = levels->begin(); it != levels->end(); ++it)
+        {
+            if (it->find("old/") != 0)
             {
                 size_t pos = it->find(".oxw");
-                *it = it->substr(0, pos);
-                ++it;
+                this->availableLevels_.push_back(it->substr(0, pos));
             }
+        }
     }
 }
Index: code/trunk/src/orxonox/controllers/NewHumanController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 6443)
+++ code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 6501)
@@ -366,5 +366,5 @@
             {
                 // Try to cast the user pointer
-                WorldEntity* wePtr = dynamic_cast<WorldEntity*>(itr->movable->getUserObject());
+                WorldEntity* wePtr = dynamic_cast<WorldEntity*>(Ogre::any_cast<OrxonoxClass*>(itr->movable->getUserAny()));
                 if (wePtr)
                 {
Index: code/trunk/src/orxonox/graphics/Camera.cc
===================================================================
--- code/trunk/src/orxonox/graphics/Camera.cc	(revision 6443)
+++ code/trunk/src/orxonox/graphics/Camera.cc	(revision 6501)
@@ -62,5 +62,5 @@
 
         this->camera_ = this->getScene()->getSceneManager()->createCamera(getUniqueNumberString());
-        this->camera_->setUserObject(this);
+        static_cast<Ogre::MovableObject*>(this->camera_)->setUserAny(Ogre::Any(static_cast<OrxonoxClass*>(this)));
         this->cameraNode_ = this->getScene()->getRootSceneNode()->createChildSceneNode();
         this->attachNode(this->cameraNode_);
Index: code/trunk/src/orxonox/worldentities/WorldEntity.cc
===================================================================
--- code/trunk/src/orxonox/worldentities/WorldEntity.cc	(revision 6443)
+++ code/trunk/src/orxonox/worldentities/WorldEntity.cc	(revision 6501)
@@ -474,5 +474,5 @@
     {
         this->node_->attachObject(object);
-        object->setUserObject(this);
+        object->setUserAny(Ogre::Any(static_cast<OrxonoxClass*>(this)));
     }
 
@@ -489,5 +489,5 @@
     void WorldEntity::detachOgreObject(Ogre::MovableObject* object)
     {
-        object->setUserObject(NULL);
+        object->setUserAny(Ogre::Any(static_cast<OrxonoxClass*>(NULL)));
         this->node_->detachObject(object);
     }
Index: code/trunk/src/orxonox/worldentities/WorldEntity.h
===================================================================
--- code/trunk/src/orxonox/worldentities/WorldEntity.h	(revision 6443)
+++ code/trunk/src/orxonox/worldentities/WorldEntity.h	(revision 6501)
@@ -33,5 +33,4 @@
 #include "OrxonoxPrereqs.h"
 
-#include <OgreUserDefinedObject.h>
 #ifdef ORXONOX_RELEASE
 #  include <OgreSceneNode.h>
@@ -70,5 +69,5 @@
         Collision shapes: These are controlled by the internal WorldEntityCollisionShape. @see WorldEntityCollisionShape.
     */
-    class _OrxonoxExport WorldEntity : public BaseObject, public Synchronisable, public btMotionState, public Ogre::UserDefinedObject
+    class _OrxonoxExport WorldEntity : public BaseObject, public Synchronisable, public btMotionState
     {
         friend class Scene;