Index: code/trunk/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 6501)
+++ code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 6502)
@@ -65,12 +65,12 @@
         {
             // Multiply with 0.8 to make them a bit slower
-            this->getControllableEntity()->rotateYaw(-0.8 * sgn(coord.x) * coord.x*coord.x);
-            this->getControllableEntity()->rotatePitch(0.8 * sgn(coord.y) * coord.y*coord.y);
+            this->getControllableEntity()->rotateYaw(-0.8f * sgn(coord.x) * coord.x*coord.x);
+            this->getControllableEntity()->rotatePitch(0.8f * sgn(coord.y) * coord.y*coord.y);
         }
 
         if (this->target_ && distance < 200 && this->getControllableEntity()->getVelocity().squaredLength() > this->target_->getVelocity().squaredLength())
-            this->getControllableEntity()->moveFrontBack(-0.5); // They don't brake with full power to give the player a chance
+            this->getControllableEntity()->moveFrontBack(-0.5f); // They don't brake with full power to give the player a chance
         else
-            this->getControllableEntity()->moveFrontBack(0.8);
+            this->getControllableEntity()->moveFrontBack(0.8f);
     }
 
Index: code/trunk/src/orxonox/controllers/NewHumanController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 6501)
+++ code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 6502)
@@ -74,8 +74,8 @@
         RegisterObject(NewHumanController);
 
-        overlaySize_ = 0.08;
-        arrowsSize_ = 0.4;
-
-        damageOverlayTime_ = 0.6;
+        overlaySize_ = 0.08f;
+        arrowsSize_ = 0.4f;
+
+        damageOverlayTime_ = 0.6f;
 
         controlMode_ = 0;
@@ -101,6 +101,6 @@
             centerOverlay_ = new OrxonoxOverlay(this);
             centerOverlay_->setBackgroundMaterial("Orxonox/CenterOverlay");
-            centerOverlay_->setSize(Vector2(overlaySize_ * 2.5, overlaySize_ * 2.5));
-            centerOverlay_->setPosition(Vector2(0.5 - overlaySize_*2.5/2.0, 0.5 - overlaySize_*2.5/2.0));
+            centerOverlay_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
+            centerOverlay_->setPosition(Vector2(0.5f - overlaySize_*2.5f/2.0f, 0.5f - overlaySize_*2.5f/2.0f));
             centerOverlay_->hide();
 
@@ -109,24 +109,24 @@
                 damageOverlayTop_ = new OrxonoxOverlay(this);
                 damageOverlayTop_->setBackgroundMaterial("Orxonox/DamageOverlayTop");
-                damageOverlayTop_->setSize(Vector2(overlaySize_ * 2.5, overlaySize_ * 2.5));
-                damageOverlayTop_->setPosition(Vector2(0.5 - overlaySize_*2.5/2.0, 0.5 - overlaySize_*2.5/2.0));
+                damageOverlayTop_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
+                damageOverlayTop_->setPosition(Vector2(0.5f - overlaySize_*2.5f/2.0f, 0.5f - overlaySize_*2.5f/2.0f));
                 damageOverlayTop_->hide();
 
                 damageOverlayRight_ = new OrxonoxOverlay(this);
                 damageOverlayRight_->setBackgroundMaterial("Orxonox/DamageOverlayRight");
-                damageOverlayRight_->setSize(Vector2(overlaySize_ * 2.5, overlaySize_ * 2.5));
-                damageOverlayRight_->setPosition(Vector2(0.5 - overlaySize_*2.5/2.0, 0.5 - overlaySize_*2.5/2.0));
+                damageOverlayRight_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
+                damageOverlayRight_->setPosition(Vector2(0.5f - overlaySize_*2.5f/2.0f, 0.5f - overlaySize_*2.5f/2.0f));
                 damageOverlayRight_->hide();
 
                 damageOverlayBottom_ = new OrxonoxOverlay(this);
                 damageOverlayBottom_->setBackgroundMaterial("Orxonox/DamageOverlayBottom");
-                damageOverlayBottom_->setSize(Vector2(overlaySize_ * 2.5, overlaySize_ * 2.5));
-                damageOverlayBottom_->setPosition(Vector2(0.5 - overlaySize_*2.5/2.0, 0.5 - overlaySize_*2.5/2.0));
+                damageOverlayBottom_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
+                damageOverlayBottom_->setPosition(Vector2(0.5f - overlaySize_*2.5f/2.0f, 0.5f - overlaySize_*2.5f/2.0f));
                 damageOverlayBottom_->hide();
 
                 damageOverlayLeft_ = new OrxonoxOverlay(this);
                 damageOverlayLeft_->setBackgroundMaterial("Orxonox/DamageOverlayLeft");
-                damageOverlayLeft_->setSize(Vector2(overlaySize_ * 2.5, overlaySize_ * 2.5));
-                damageOverlayLeft_->setPosition(Vector2(0.5 - overlaySize_*2.5/2.0, 0.5 - overlaySize_*2.5/2.0));
+                damageOverlayLeft_->setSize(Vector2(overlaySize_ * 2.5f, overlaySize_ * 2.5f));
+                damageOverlayLeft_->setPosition(Vector2(0.5f - overlaySize_*2.5f/2.0f, 0.5f - overlaySize_*2.5f/2.0f));
                 damageOverlayLeft_->hide();
             }
@@ -136,28 +136,28 @@
                 arrowsOverlay1_ = new OrxonoxOverlay(this);
                 arrowsOverlay1_->setBackgroundMaterial("Orxonox/DirectionArrows1");
-                arrowsOverlay1_->setSize(Vector2(0.02727, 0.36 * arrowsSize_));
-                arrowsOverlay1_->setPickPoint(Vector2(0.5, 0.5));
-                arrowsOverlay1_->setPosition(Vector2(0.5, 0.5));
+                arrowsOverlay1_->setSize(Vector2(0.02727f, 0.36f * arrowsSize_));
+                arrowsOverlay1_->setPickPoint(Vector2(0.5f, 0.5f));
+                arrowsOverlay1_->setPosition(Vector2(0.5f, 0.5f));
                 arrowsOverlay1_->hide();
 
                 arrowsOverlay2_ = new OrxonoxOverlay(this);
                 arrowsOverlay2_->setBackgroundMaterial("Orxonox/DirectionArrows2");
-                arrowsOverlay2_->setSize(Vector2(0.02727, 0.59 * arrowsSize_));
-                arrowsOverlay2_->setPickPoint(Vector2(0.5, 0.5));
-                arrowsOverlay2_->setPosition(Vector2(0.5, 0.5));
+                arrowsOverlay2_->setSize(Vector2(0.02727f, 0.59f * arrowsSize_));
+                arrowsOverlay2_->setPickPoint(Vector2(0.5f, 0.5f));
+                arrowsOverlay2_->setPosition(Vector2(0.5f, 0.5f));
                 arrowsOverlay2_->hide();
 
                 arrowsOverlay3_ = new OrxonoxOverlay(this);
                 arrowsOverlay3_->setBackgroundMaterial("Orxonox/DirectionArrows3");
-                arrowsOverlay3_->setSize(Vector2(0.02727, 0.77 * arrowsSize_));
-                arrowsOverlay3_->setPickPoint(Vector2(0.5, 0.5));
-                arrowsOverlay3_->setPosition(Vector2(0.5, 0.5));
+                arrowsOverlay3_->setSize(Vector2(0.02727f, 0.77f * arrowsSize_));
+                arrowsOverlay3_->setPickPoint(Vector2(0.5f, 0.5f));
+                arrowsOverlay3_->setPosition(Vector2(0.5f, 0.5f));
                 arrowsOverlay3_->hide();
 
                 arrowsOverlay4_ = new OrxonoxOverlay(this);
                 arrowsOverlay4_->setBackgroundMaterial("Orxonox/DirectionArrows4");
-                arrowsOverlay4_->setSize(Vector2(0.02727, arrowsSize_));
-                arrowsOverlay4_->setPickPoint(Vector2(0.5, 0.5));
-                arrowsOverlay4_->setPosition(Vector2(0.5, 0.5));
+                arrowsOverlay4_->setSize(Vector2(0.02727f, arrowsSize_));
+                arrowsOverlay4_->setPickPoint(Vector2(0.5f, 0.5f));
+                arrowsOverlay4_->setPosition(Vector2(0.5f, 0.5f));
                 arrowsOverlay4_->hide();
             }
@@ -213,5 +213,5 @@
                         this->showOverlays();
 
-                    this->crossHairOverlay_->setPosition(Vector2(static_cast<float>(this->currentYaw_)/2*-1+.5-overlaySize_/2, static_cast<float>(this->currentPitch_)/2*-1+.5-overlaySize_/2));
+                    this->crossHairOverlay_->setPosition(Vector2(static_cast<float>(this->currentYaw_)/2*-1+.5f-overlaySize_/2, static_cast<float>(this->currentPitch_)/2*-1+.5f-overlaySize_/2));
 
                     if (this->controlMode_ == 0 || (this->controlMode_ == 1 && this->firemode_ == 1))
@@ -299,5 +299,5 @@
             relativeHit.normalise();
 
-            float threshold = 0.3;
+            float threshold = 0.3f;
             if (relativeHit.x > threshold) // Left
             {
@@ -343,5 +343,5 @@
         Ogre::RaySceneQuery * rsq = HumanController::localController_s->getControllableEntity()->getScene()->getSceneManager()->createRayQuery(Ogre::Ray());
 
-        Ogre::Ray mouseRay = HumanController::localController_s->getControllableEntity()->getCamera()->getOgreCamera()->getCameraToViewportRay(static_cast<float>(this->currentYaw_)/2*-1+.5, static_cast<float>(this->currentPitch_)/2*-1+.5);
+        Ogre::Ray mouseRay = HumanController::localController_s->getControllableEntity()->getCamera()->getOgreCamera()->getCameraToViewportRay(static_cast<float>(this->currentYaw_)/2*-1+.5f, static_cast<float>(this->currentPitch_)/2*-1+.5f);
 
         rsq->setRay(mouseRay);
@@ -505,22 +505,22 @@
             float distance = sqrt(pow(static_cast<float>(this->currentYaw_)/2*-1,2) + pow(static_cast<float>(this->currentPitch_)/2*-1,2));
 
-            if (distance > 0.04 && distance <= 0.59 * arrowsSize_ / 2.0 )
-            {
-                this->arrowsOverlay1_->setRotation(Degree(-90 + -1.0 * atan2(static_cast<float>(this->currentPitch_)/2*-1, static_cast<float>(this->currentYaw_)/2*-1) / (2.0f * Ogre::Math::PI) * 360.0f));
+            if (distance > 0.04f && distance <= 0.59f * arrowsSize_ / 2.0f )
+            {
+                this->arrowsOverlay1_->setRotation(Degree(-90 + -1.0f * atan2(static_cast<float>(this->currentPitch_)/2*-1, static_cast<float>(this->currentYaw_)/2*-1) / (2.0f * Ogre::Math::PI) * 360.0f));
                 this->arrowsOverlay1_->show();
             }
-            else if (distance > 0.59 * arrowsSize_ / 2.0 && distance <= 0.77 * arrowsSize_ / 2.0 )
-            {
-                this->arrowsOverlay2_->setRotation(Degree(-90 + -1.0 * atan2(static_cast<float>(this->currentPitch_)/2*-1, static_cast<float>(this->currentYaw_)/2*-1) / (2.0f * Ogre::Math::PI) * 360.0f));
+            else if (distance > 0.59f * arrowsSize_ / 2.0f && distance <= 0.77f * arrowsSize_ / 2.0f )
+            {
+                this->arrowsOverlay2_->setRotation(Degree(-90 + -1.0f * atan2(static_cast<float>(this->currentPitch_)/2*-1, static_cast<float>(this->currentYaw_)/2*-1) / (2.0f * Ogre::Math::PI) * 360.0f));
                 this->arrowsOverlay2_->show();
             }
-            else if (distance > 0.77 * arrowsSize_ / 2.0 && distance <= arrowsSize_ / 2.0)
-            {
-                this->arrowsOverlay3_->setRotation(Degree(-90 + -1.0 * atan2(static_cast<float>(this->currentPitch_)/2*-1, static_cast<float>(this->currentYaw_)/2*-1) / (2.0f * Ogre::Math::PI) * 360.0f));
+            else if (distance > 0.77f * arrowsSize_ / 2.0f && distance <= arrowsSize_ / 2.0f)
+            {
+                this->arrowsOverlay3_->setRotation(Degree(-90 + -1.0f * atan2(static_cast<float>(this->currentPitch_)/2*-1, static_cast<float>(this->currentYaw_)/2*-1) / (2.0f * Ogre::Math::PI) * 360.0f));
                 this->arrowsOverlay3_->show();
             }
-            else if (distance > arrowsSize_ / 2.0)
-            {
-                this->arrowsOverlay4_->setRotation(Degree(-90 + -1.0 * atan2(static_cast<float>(this->currentPitch_)/2*-1, static_cast<float>(this->currentYaw_)/2*-1) / (2.0f * Ogre::Math::PI) * 360.0f));
+            else if (distance > arrowsSize_ / 2.0f)
+            {
+                this->arrowsOverlay4_->setRotation(Degree(-90 + -1.0f * atan2(static_cast<float>(this->currentPitch_)/2*-1, static_cast<float>(this->currentYaw_)/2*-1) / (2.0f * Ogre::Math::PI) * 360.0f));
                 this->arrowsOverlay4_->show();
             }
Index: code/trunk/src/orxonox/controllers/WaypointPatrolController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/WaypointPatrolController.cc	(revision 6501)
+++ code/trunk/src/orxonox/controllers/WaypointPatrolController.cc	(revision 6502)
@@ -68,5 +68,5 @@
                 this->moveToTargetPosition();
 
-            if (this->getControllableEntity() && this->isCloseAtTarget(1000) && this->isLookingAtTarget(Ogre::Math::PI / 20.0))
+            if (this->getControllableEntity() && this->isCloseAtTarget(1000) && this->isLookingAtTarget(Ogre::Math::PI / 20.0f))
                 this->getControllableEntity()->fire(0);
         }
@@ -85,5 +85,5 @@
 
         Vector3 myposition = this->getControllableEntity()->getPosition();
-        float shortestsqdistance = static_cast<unsigned int>(-1);
+        float shortestsqdistance = (float)static_cast<unsigned int>(-1);
 
         for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it != ObjectList<Pawn>::end(); ++it)
Index: code/trunk/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- code/trunk/src/orxonox/overlays/InGameConsole.cc	(revision 6501)
+++ code/trunk/src/orxonox/overlays/InGameConsole.cc	(revision 6502)
@@ -200,9 +200,9 @@
         this->consoleOverlayBorder_->setBorderSize(16, 16, 0, 16);
         this->consoleOverlayBorder_->setBorderMaterialName("ConsoleBorder");
-        this->consoleOverlayBorder_->setLeftBorderUV(0.0, 0.49, 0.5, 0.51);
-        this->consoleOverlayBorder_->setRightBorderUV(0.5, 0.49, 1.0, 0.5);
-        this->consoleOverlayBorder_->setBottomBorderUV(0.49, 0.5, 0.51, 1.0);
-        this->consoleOverlayBorder_->setBottomLeftBorderUV(0.0, 0.5, 0.5, 1.0);
-        this->consoleOverlayBorder_->setBottomRightBorderUV(0.5, 0.5, 1.0, 1.0);
+        this->consoleOverlayBorder_->setLeftBorderUV(0.0f, 0.49f, 0.5f, 0.51f);
+        this->consoleOverlayBorder_->setRightBorderUV(0.5f, 0.49f, 1.0f, 0.5f);
+        this->consoleOverlayBorder_->setBottomBorderUV(0.49f, 0.5f, 0.51f, 1.0f);
+        this->consoleOverlayBorder_->setBottomLeftBorderUV(0.0f, 0.5f, 0.5f, 1.0f);
+        this->consoleOverlayBorder_->setBottomRightBorderUV(0.5f, 0.5f, 1.0f, 1.0f);
         this->consoleOverlayContainer_->addChild(this->consoleOverlayBorder_);
 
@@ -254,5 +254,5 @@
         // move overlay "above" the top edge of the screen
         // we take -1.3 because the border makes the panel bigger
-        this->consoleOverlayContainer_->setTop(-1.3 * this->relativeHeight);
+        this->consoleOverlayContainer_->setTop(-1.3f * this->relativeHeight);
 
         COUT(4) << "Info: InGameConsole initialized" << std::endl;
@@ -332,5 +332,5 @@
 
         this->consoleOverlayCursor_->setCaption(std::string(pos,' ') + cursorSymbol_);
-        this->consoleOverlayCursor_->setTop(static_cast<int>(this->windowH_ * this->relativeHeight) - 24);
+        this->consoleOverlayCursor_->setTop(static_cast<int>(this->windowH_ * this->relativeHeight) - 24.0f);
     }
 
@@ -369,5 +369,5 @@
                 // enlarge oldTop a little bit so that this exponential function
                 // reaches 0 before infinite time has passed...
-                float deltaScroll = (oldTop - 0.01) * time.getDeltaTime() * this->scrollSpeed_;
+                float deltaScroll = (oldTop - 0.01f) * time.getDeltaTime() * this->scrollSpeed_;
                 if (oldTop - deltaScroll >= 0)
                 {
@@ -384,9 +384,9 @@
                 // scrolling up
                 // note: +0.01 for the same reason as when scrolling down
-                float deltaScroll = (1.3 * this->relativeHeight + 0.01 + oldTop) * time.getDeltaTime() * this->scrollSpeed_;
+                float deltaScroll = (1.3f * this->relativeHeight + 0.01f + oldTop) * time.getDeltaTime() * this->scrollSpeed_;
                 if (oldTop - deltaScroll <= -1.3 * this->relativeHeight)
                 {
                     // window has completely scrolled up
-                    this->consoleOverlayContainer_->setTop(-1.3 * this->relativeHeight);
+                    this->consoleOverlayContainer_->setTop(-1.3f * this->relativeHeight);
                     this->scroll_ = 0;
                     this->consoleOverlay_->hide();
@@ -424,8 +424,8 @@
         this->windowW_ = newWidth;
         this->windowH_ = newHeight;
-        this->consoleOverlayBorder_->setWidth(static_cast<int>(this->windowW_* this->relativeWidth));
-        this->consoleOverlayBorder_->setHeight(static_cast<int>(this->windowH_ * this->relativeHeight));
-        this->consoleOverlayNoise_->setWidth(static_cast<int>(this->windowW_ * this->relativeWidth) - 10);
-        this->consoleOverlayNoise_->setHeight(static_cast<int>(this->windowH_ * this->relativeHeight) - 5);
+        this->consoleOverlayBorder_->setWidth((float)(int)(this->windowW_* this->relativeWidth));
+        this->consoleOverlayBorder_->setHeight((float)(int)(this->windowH_ * this->relativeHeight));
+        this->consoleOverlayNoise_->setWidth((float)(int)(this->windowW_ * this->relativeWidth) - 10.0f);
+        this->consoleOverlayNoise_->setHeight((float)(int)(this->windowH_ * this->relativeHeight) - 5.0f);
         this->consoleOverlayNoise_->setTiling(consoleOverlayNoise_->getWidth() / (50.0f * this->noiseSize_), consoleOverlayNoise_->getHeight() / (50.0f * this->noiseSize_));
 
@@ -440,6 +440,6 @@
         for (int i = 0; i < LINES; i++)
         {
-            this->consoleOverlayTextAreas_[i]->setWidth(this->desiredTextWidth_);
-            this->consoleOverlayTextAreas_[i]->setTop(static_cast<int>(this->windowH_ * this->relativeHeight) - 24 - 14*i);
+            this->consoleOverlayTextAreas_[i]->setWidth((float)this->desiredTextWidth_);
+            this->consoleOverlayTextAreas_[i]->setTop((float)(int)(this->windowH_ * this->relativeHeight) - 24 - 14*i);
         }
 
@@ -556,30 +556,30 @@
         switch (type)
         {
-        case Shell::Error:   colourTop = ColourValue(0.95, 0.25, 0.25, 1.00);
-                          colourBottom = ColourValue(1.00, 0.50, 0.50, 1.00); break;
-
-        case Shell::Warning: colourTop = ColourValue(0.95, 0.50, 0.20, 1.00);
-                          colourBottom = ColourValue(1.00, 0.70, 0.50, 1.00); break;
-
-        case Shell::Info:    colourTop = ColourValue(0.50, 0.50, 0.95, 1.00);
-                          colourBottom = ColourValue(0.80, 0.80, 1.00, 1.00); break;
-
-        case Shell::Debug:   colourTop = ColourValue(0.65, 0.48, 0.44, 1.00);
-                          colourBottom = ColourValue(1.00, 0.90, 0.90, 1.00); break;
-
-        case Shell::Verbose: colourTop = ColourValue(0.40, 0.20, 0.40, 1.00);
-                          colourBottom = ColourValue(0.80, 0.60, 0.80, 1.00); break;
-
-        case Shell::Ultra:   colourTop = ColourValue(0.21, 0.69, 0.21, 1.00);
-                          colourBottom = ColourValue(0.80, 1.00, 0.80, 1.00); break;
-
-        case Shell::Command: colourTop = ColourValue(0.80, 0.80, 0.80, 1.00);
-                          colourBottom = ColourValue(0.90, 0.90, 0.90, 0.90); break;
-
-        case Shell::Hint:    colourTop = ColourValue(0.80, 0.80, 0.80, 1.00);
-                          colourBottom = ColourValue(0.90, 0.90, 0.90, 1.00); break;
-
-        default:             colourTop = ColourValue(0.90, 0.90, 0.90, 1.00);
-                          colourBottom = ColourValue(1.00, 1.00, 1.00, 1.00); break;
+        case Shell::Error:   colourTop = ColourValue(0.95f, 0.25f, 0.25f, 1.00f);
+                          colourBottom = ColourValue(1.00f, 0.50f, 0.50f, 1.00f); break;
+
+        case Shell::Warning: colourTop = ColourValue(0.95f, 0.50f, 0.20f, 1.00f);
+                          colourBottom = ColourValue(1.00f, 0.70f, 0.50f, 1.00f); break;
+
+        case Shell::Info:    colourTop = ColourValue(0.50f, 0.50f, 0.95f, 1.00f);
+                          colourBottom = ColourValue(0.80f, 0.80f, 1.00f, 1.00f); break;
+
+        case Shell::Debug:   colourTop = ColourValue(0.65f, 0.48f, 0.44f, 1.00f);
+                          colourBottom = ColourValue(1.00f, 0.90f, 0.90f, 1.00f); break;
+
+        case Shell::Verbose: colourTop = ColourValue(0.40f, 0.20f, 0.40f, 1.00f);
+                          colourBottom = ColourValue(0.80f, 0.60f, 0.80f, 1.00f); break;
+
+        case Shell::Ultra:   colourTop = ColourValue(0.21f, 0.69f, 0.21f, 1.00f);
+                          colourBottom = ColourValue(0.80f, 1.00f, 0.80f, 1.00f); break;
+
+        case Shell::Command: colourTop = ColourValue(0.80f, 0.80f, 0.80f, 1.00f);
+                          colourBottom = ColourValue(0.90f, 0.90f, 0.90f, 0.90f); break;
+
+        case Shell::Hint:    colourTop = ColourValue(0.80f, 0.80f, 0.80f, 1.00f);
+                          colourBottom = ColourValue(0.90f, 0.90f, 0.90f, 1.00f); break;
+
+        default:             colourTop = ColourValue(0.90f, 0.90f, 0.90f, 1.00f);
+                          colourBottom = ColourValue(1.00f, 1.00f, 1.00f, 1.00f); break;
         }
 
Index: code/trunk/src/orxonox/overlays/Map.cc
===================================================================
--- code/trunk/src/orxonox/overlays/Map.cc	(revision 6501)
+++ code/trunk/src/orxonox/overlays/Map.cc	(revision 6502)
@@ -179,6 +179,6 @@
             //m_pOverlayPanel->setPosition(10, 10);
             //m_pOverlayPanel->setDimensions(600, 400);
-            m_pOverlayPanel->setPosition(0.01, 0.003);
-            m_pOverlayPanel->setDimensions(0.5, 0.4);
+            m_pOverlayPanel->setPosition(0.01f, 0.003f);
+            m_pOverlayPanel->setDimensions(0.5f, 0.4f);
             // Give overlay a texture
             m_pOverlayPanel->setMaterialName("RttMat");
@@ -187,15 +187,15 @@
             //Add Borders
             Ogre::BorderPanelOverlayElement* oBorder = static_cast<Ogre::BorderPanelOverlayElement*>(Ogre::OverlayManager::getSingletonPtr()->createOverlayElement("BorderPanel", "MapBorderPanel" + getUniqueNumberString()));
-            oBorder->setBorderSize( 0.003, 0.003 );
-            oBorder->setDimensions(0.5, 0.4);
+            oBorder->setBorderSize( 0.003f, 0.003f );
+            oBorder->setDimensions(0.5f, 0.4f);
             oBorder->setBorderMaterialName("StatsBorder");
-            oBorder->setTopBorderUV(0.49, 0.0, 0.51, 0.5);
-            oBorder->setTopLeftBorderUV(0.0, 0.0, 0.5, 0.5);
-            oBorder->setTopRightBorderUV(0.5, 0.0, 1.0, 0.5);
-            oBorder->setLeftBorderUV(0.0, 0.49, 0.5, 0.51);
-            oBorder->setRightBorderUV(0.5, 0.49, 1.0, 0.5);
-            oBorder->setBottomBorderUV(0.49, 0.5, 0.51, 1.0);
-            oBorder->setBottomLeftBorderUV(0.0, 0.5, 0.5, 1.0);
-            oBorder->setBottomRightBorderUV(0.5, 0.5, 1.0, 1.0);
+            oBorder->setTopBorderUV(0.49f, 0.0f, 0.51f, 0.5f);
+            oBorder->setTopLeftBorderUV(0.0f, 0.0f, 0.5f, 0.5f);
+            oBorder->setTopRightBorderUV(0.5f, 0.0f, 1.0f, 0.5f);
+            oBorder->setLeftBorderUV(0.0f, 0.49f, 0.5f, 0.51f);
+            oBorder->setRightBorderUV(0.5f, 0.49f, 1.0f, 0.5f);
+            oBorder->setBottomBorderUV(0.49f, 0.5f, 0.51f, 1.0f);
+            oBorder->setBottomLeftBorderUV(0.0f, 0.5f, 0.5f, 1.0f);
+            oBorder->setBottomRightBorderUV(0.5f, 0.5f, 1.0f, 1.0f);
             //overlay_->add2D(oBorder);
             m_pOverlayPanel->addChild(oBorder);
@@ -329,6 +329,6 @@
                 //this->CamNodeHelper_ = this->CamNode_->createChildSceneNode();
                 //this->CamNodeHelper_->attachObject(this->Cam_);
-                    this->Cam_->setPosition(0, 0, DISTANCE);
-                    this->Cam_->pitch( static_cast<Degree>(PITCH) );
+                    this->Cam_->setPosition(0, 0, (float)DISTANCE);
+                    this->Cam_->pitch( static_cast<Degree>((float)PITCH) );
                     this->Cam_->lookAt(this->playerShipNode_->getPosition());
                 //this->Cam_->setAutoTracking(true, this->playerShipNode_);
Index: code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 6501)
+++ code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 6502)
@@ -226,5 +226,5 @@
             if (angle > 89.0f && angle < 91.0f)
             {
-                tempAspect = 1.0 / this->windowAspectRatio_;
+                tempAspect = 1.0f / this->windowAspectRatio_;
                 rotState_ = Vertical;
             }
Index: code/trunk/src/orxonox/pickup/PickupInventory.cc
===================================================================
--- code/trunk/src/orxonox/pickup/PickupInventory.cc	(revision 6501)
+++ code/trunk/src/orxonox/pickup/PickupInventory.cc	(revision 6502)
@@ -301,5 +301,5 @@
 
         CEGUI::Window* frame = winMgr->createWindow("TaharezLook/StaticImage", "orxonox/Inventory/Frame/" + id);
-        frame->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 5 + x * 70), CEGUI::UDim(0, 5 + y * 90)));
+        frame->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 5.0f + x * 70), CEGUI::UDim(0, 5.0f + y * 90)));
         frame->setSize(CEGUI::UVector2(CEGUI::UDim(0, 65), CEGUI::UDim(0, 65)));
         frame->setRiseOnClickEnabled(false);
@@ -307,5 +307,5 @@
 
         CEGUI::Window* text = winMgr->createWindow("TaharezLook/StaticText", "orxonox/Inventory/Title/" + id);
-        text->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 5 + x * 70), CEGUI::UDim(0, 70 + y * 90)));
+        text->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 5.0f + x * 70), CEGUI::UDim(0, 70.0f + y * 90)));
         text->setSize(CEGUI::UVector2(CEGUI::UDim(0, 65), CEGUI::UDim(0, 20)));
         text->setProperty("FrameEnabled", "False");
@@ -317,5 +317,5 @@
 
         CEGUI::Window* btn = winMgr->createWindow("TaharezLook/Button", "orxonox/Inventory/Items/" + id);
-        btn->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 8 + x * 70), CEGUI::UDim(0, 8 + y * 90)));
+        btn->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 8.0f + x * 70), CEGUI::UDim(0, 8.0f + y * 90)));
         btn->setSize(CEGUI::UVector2(CEGUI::UDim(0, 59), CEGUI::UDim(0, 59)));
         btn->subscribeScriptedEvent("Clicked", "PickupInventory.itemClicked");
Index: code/trunk/src/orxonox/sound/BaseSound.cc
===================================================================
--- code/trunk/src/orxonox/sound/BaseSound.cc	(revision 6501)
+++ code/trunk/src/orxonox/sound/BaseSound.cc	(revision 6502)
@@ -178,9 +178,9 @@
     void BaseSound::setPitch(float pitch)
     {
-        if (pitch > 2 || pitch < 0.5)
+        if (pitch > 2 || pitch < 0.5f)
         {
             COUT(2) << "Sound warning: pitch out of range, cropping value." << std::endl;
-            pitch = pitch > 2 ? 2 : pitch;
-            pitch = pitch < 0.5 ? 0.5 : pitch;
+            pitch = pitch > 2.0f ? 2.0f : pitch;
+            pitch = pitch < 0.5f ? 0.5f : pitch;
         }
         this->pitch_ = pitch;
Index: code/trunk/src/orxonox/sound/SoundBuffer.cc
===================================================================
--- code/trunk/src/orxonox/sound/SoundBuffer.cc	(revision 6501)
+++ code/trunk/src/orxonox/sound/SoundBuffer.cc	(revision 6502)
@@ -108,11 +108,11 @@
         {
         case SEEK_SET:
-            stream->seek(offset);
+            stream->seek((size_t)offset);
             break;
         case SEEK_CUR:
-            stream->skip(offset);
+            stream->skip((size_t)offset);
             break;
         case SEEK_END:
-            stream->seek(stream->size() + offset);
+            stream->seek(stream->size() + (size_t)offset);
             break;
         default: